// Auto-generated. Do not edit!

// (in-package rc_pick_client.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let LoadCarrier = require('../msg/LoadCarrier.js');

//-----------------------------------------------------------

let rc_common_msgs = _finder('rc_common_msgs');

//-----------------------------------------------------------

class SetLoadCarrierRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.load_carrier = null;
    }
    else {
      if (initObj.hasOwnProperty('load_carrier')) {
        this.load_carrier = initObj.load_carrier
      }
      else {
        this.load_carrier = new LoadCarrier();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetLoadCarrierRequest
    // Serialize message field [load_carrier]
    bufferOffset = LoadCarrier.serialize(obj.load_carrier, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetLoadCarrierRequest
    let len;
    let data = new SetLoadCarrierRequest(null);
    // Deserialize message field [load_carrier]
    data.load_carrier = LoadCarrier.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += LoadCarrier.getMessageSize(object.load_carrier);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_pick_client/SetLoadCarrierRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '87a7fb3d4572257c3d811701930cad8c';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    
    
    LoadCarrier load_carrier
    
    
    ================================================================================
    MSG: rc_pick_client/LoadCarrier
    # This represents a load carrier by its geometry and its pose in the pose_frame reference frame
    
    string id
    
    # Required
    Box outer_dimensions
    
    # Required
    Box inner_dimensions
    
    # Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
    Rectangle rim_thickness
    
    geometry_msgs/PoseStamped pose
    
    ================================================================================
    MSG: rc_pick_client/Box
    # Definition of a box
    
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: rc_pick_client/Rectangle
    # Definition of a rectangle
    
    float64 x
    float64 y
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetLoadCarrierRequest(null);
    if (msg.load_carrier !== undefined) {
      resolved.load_carrier = LoadCarrier.Resolve(msg.load_carrier)
    }
    else {
      resolved.load_carrier = new LoadCarrier()
    }

    return resolved;
    }
};

class SetLoadCarrierResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.return_code = null;
    }
    else {
      if (initObj.hasOwnProperty('return_code')) {
        this.return_code = initObj.return_code
      }
      else {
        this.return_code = new rc_common_msgs.msg.ReturnCode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetLoadCarrierResponse
    // Serialize message field [return_code]
    bufferOffset = rc_common_msgs.msg.ReturnCode.serialize(obj.return_code, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetLoadCarrierResponse
    let len;
    let data = new SetLoadCarrierResponse(null);
    // Deserialize message field [return_code]
    data.return_code = rc_common_msgs.msg.ReturnCode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += rc_common_msgs.msg.ReturnCode.getMessageSize(object.return_code);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_pick_client/SetLoadCarrierResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '89940768eec602f7650f8f061383e0f9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    rc_common_msgs/ReturnCode return_code
    
    
    ================================================================================
    MSG: rc_common_msgs/ReturnCode
    # This message shall be used in the response of services as a field called return_code.
    # Confer to ReturnCodeConsts message for commonly used return code definitions.
    
    # return codes
    # >=0 - success
    # < 0 - failure
    
    # return code
    int16 value
    
    # return message
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetLoadCarrierResponse(null);
    if (msg.return_code !== undefined) {
      resolved.return_code = rc_common_msgs.msg.ReturnCode.Resolve(msg.return_code)
    }
    else {
      resolved.return_code = new rc_common_msgs.msg.ReturnCode()
    }

    return resolved;
    }
};

module.exports = {
  Request: SetLoadCarrierRequest,
  Response: SetLoadCarrierResponse,
  md5sum() { return '8b044416e0cda6964e9251f45d5b0e6c'; },
  datatype() { return 'rc_pick_client/SetLoadCarrier'; }
};
